module csm_interface
  interface
     subroutine csm_init(csm,n,nval)
       use csm_mod
       type(csmat),intent(out) :: csm
       integer,intent(in) :: n,nval
     endsubroutine csm_init
     subroutine csm_load(csm,filename)
       use csm_mod
       type(csmat),intent(out) :: csm
       character(len=*),intent(in) :: filename
     endsubroutine csm_load
     subroutine csm_vect_pdt(csm,x,y)
       use csm_mod
       type(csmat),intent(in) :: csm
       real(kind(0.d0)),dimension(:),intent(in) :: x
       real(kind(0.d0)),dimension(:),intent(out) :: y
     endsubroutine csm_vect_pdt
     subroutine vect_csm_pdt(x,csm,y)
       use csm_mod
       real(kind(0.d0)),dimension(:),intent(in) :: x
       type(csmat),intent(in) :: csm
       real(kind(0.d0)),dimension(:),intent(out) :: y
     endsubroutine vect_csm_pdt
     subroutine csm_print(csm,i1,i2,j1,j2)
       use csm_mod
       implicit none
       type(csmat),intent(in) :: csm
       integer,intent(in) :: i1,i2,j1,j2
     endsubroutine csm_print
     subroutine csm_tprint(csm,i1,i2,j1,j2)
       use csm_mod
       implicit none
       type(csmat),intent(in) :: csm
       integer,intent(in) :: i1,i2,j1,j2
     endsubroutine csm_tprint
     subroutine mat2csm(a,csm)
       use csm_mod
       real(kind(0.d0)),dimension(:,:),intent(in)::a
       type(csmat),intent(out) :: csm
     endsubroutine mat2csm
     subroutine csm2mat(csm,a)
       use csm_mod
       type(csmat),intent(in) :: csm
       real(kind(0.d0)),allocatable,dimension(:,:),intent(out) :: a
     endsubroutine csm2mat
  endinterface
endmodule csm_interface
