! reads a hb text file and stores in the hbmat data structure
! only handles Real Unsymmetric Assemblied data for square matrices
subroutine csm_load(csm,filename)
  use hbf_mod
  use csm_mod
  use misc_interface
  use hbf_interface
  implicit none
  type(csmat),intent(out) :: csm
  character(len=*),intent(in) :: filename
  type(hbfile) :: hbf
  integer :: fileunit,ios,i,n

  call hbf_load(hbf,filename)

  if(hbf%nrow/=hbf%ncol) call error(301)
  if(hbf%ncol<1) call error(302)
  if(hbf%nrow<1) call error(302)
  if(hbf%ptrcrd<1) call error(303)
  if(hbf%nnzero<1) call error(303)
  if(hbf%valcrd<1) call error(303)
  if(hbf%mxtype(1:1)/='R') call error(304)
  if(hbf%mxtype(2:2)/='U') call error(304)
  if(hbf%mxtype(3:3)/='A') call error(304)

  call csm_init(csm,hbf%ncol,hbf%nnzero)

  fileunit=get_fileunit()
  open(unit=fileunit,file=hbf%filename,status='old',iostat=ios)
  if(ios/=0) call error(201)

  n=4
  if(0<hbf%rhscrd) n=n+1
  do i=1,n
     read(unit=fileunit,fmt='(a)',iostat=ios)
     if(ios/=0) call error(203)
  enddo

  read(unit=fileunit,fmt=hbf%ptrfmt,iostat=ios) csm%colptr(1:csm%n+1)
  if(ios/=0) call error(301)
  read(unit=fileunit,fmt=hbf%indfmt,iostat=ios) csm%rowind(1:csm%nval)
  if(ios/=0 ) call error(302)
  read(unit=fileunit,fmt=hbf%valfmt,iostat=ios) csm%values(1:csm%nval)
  if(ios/=0 ) call error(302)
 
  close(unit=fileunit)
endsubroutine csm_load
