! prints the [i1,i2]x[j1,j2] subsection of a matrix
subroutine csm_print(csm,i1,i2,j1,j2)
  use csm_mod
  use misc_interface
  implicit none
  type(csmat),intent(in) :: csm
  integer,intent(in) :: i1,i2,j1,j2
  real(kind(0.d0)),allocatable,dimension(:) :: row  
  integer :: i,j,k

  if(i1<1) call error(403)
  if(i2>csm%n) call error(404)
  if(j1<1) call error(405)
  if(j2>csm%n) call error(406)

  if((i1<=i2).and.(j1<=j2)) then
     call d_vect_alloc(row,j2-j1+1)
     do i=i1,i2 ! for each row i
        do j=j1,j2 ! for each column j
           row(j)=0
           do k=csm%colptr(j),csm%colptr(j+1)-1 ! searches in the column j 
              if(csm%rowind(k)==i) row(j)=csm%values(k) ! finds the row i
              if(csm%rowind(k)>=i) exit
           enddo
        enddo
     print *,row
     enddo
  endif
endsubroutine csm_print
