! prints the [i1,i2]x[j1,j2] subsection of a matrix,
! in a transposed layout (faster, less redundant loops)
subroutine csm_tprint(csm,i1,i2,j1,j2)
  use csm_mod
  use misc_interface
  implicit none
  type(csmat),intent(in) :: csm
  integer,intent(in) :: i1,i2,j1,j2
  real(kind(0.d0)),allocatable,dimension(:) :: col  
  integer :: j,k

  if(i1<1) call error(403)
  if(i2>csm%n) call error(404)
  if(j1<1) call error(405)
  if(j2>csm%n) call error(406)

  if((i1<=i2).and.(j1<=j2)) then
     call d_vect_alloc(col,i2-i1+1)
     do j=j1,j2 ! for each col j
        col=0
        do k=csm%colptr(j),csm%colptr(j+1)-1
           if(csm%rowind(k)>i2) exit
           if(csm%rowind(k)>=i1) col(csm%rowind(k))=csm%values(k) ! row i
        enddo
        print *,col
     enddo
  endif
endsubroutine csm_tprint
