! convert a square array matrix into a compressed matrix
subroutine mat2csm(a,csm)
  use csm_mod
  implicit none
  real(kind(0.d0)),dimension(:,:),intent(in)::a
  type(csmat),intent(out) :: csm
  integer::n,nval,i,j
  interface
     subroutine csm_init(csm,n,nval)
       use csm_mod
       type(csmat),intent(out) :: csm
       integer,intent(in) :: n,nval
     endsubroutine csm_init
  endinterface

  n=size(a,1)
  nval=0
  do i=1,n
     do j=1,n
        if(a(i,j)/=0.d0) nval=nval+1
     enddo
  enddo

  call csm_init(csm,n,nval)

  nval=0
  do j=1,n
     csm%colptr(j)=nval+1
     do i=1,n
        if(a(i,j)/=0.d0) then
           nval=nval+1
           csm%rowind(nval)=i
           csm%values(nval)=a(i,j)
        endif
     enddo
  enddo
  csm%colptr(n+1)=nval+1

endsubroutine mat2csm
