! reads a hb text file and stores the information in the hbf data structure
subroutine hbf_load(hbf,filename)
  use hbf_mod
  use misc_interface
  implicit none
  type(hbfile),intent(out) :: hbf
  character(len=*),intent(in) :: filename
  integer :: fileunit,ios,as
  
  hbf%filename = filename
  
  fileunit=get_fileunit()
  open(unit=fileunit,file=filename,status='old',iostat=ios)
  if(ios/=0) call error(201)
  
  read (unit=fileunit,fmt='(a72,a8)',iostat=ios) hbf%title,hbf%key
  if(ios/=0) call error(203)
  read(unit=fileunit,fmt='(5i14)',iostat=ios) &
       hbf%totcrd,hbf%ptrcrd,hbf%indcrd,hbf%valcrd,hbf%rhscrd
  if(ios/=0) call error(203)
  read(unit=fileunit,fmt='(a3,11x,4i14)',iostat=ios) &
       hbf%mxtype,hbf%nrow,hbf%ncol,hbf%nnzero,hbf%neltvl
  if(ios/=0) call error(203)
  read(unit=fileunit,fmt='(2a16,2a20)',iostat=ios) &
       hbf%ptrfmt,hbf%indfmt,hbf%valfmt,hbf%rhsfmt
  if(ios/=0) call error(203)
  if(0<hbf%rhscrd)then
     read(unit=fileunit,fmt='(a3,11x,2a14)',iostat=ios) hbf%rhstyp,hbf%nrhs,hbf%nrhsix
     if(ios/=0) call error(203)
  endif
  close(unit=fileunit)
endsubroutine hbf_load
