! reads the command-line parameters previously stored in a text file
! by a shell script, and shows a syntaw help if needed
subroutine msolve_params(filename,logtag,n,i_max,imax_flag,eps_max,eps_flag,&
     dim_k,dimk_flag,info_flag,log_flag,lanczos_flag,bicgstab_flag,gmres_flag)
  use misc_interface
  implicit none
  character(len=*),intent(in) :: filename
  character(len=20),intent(out) :: logtag
  real(kind(0.d0)),intent(out) :: eps_max
  integer,intent(out) :: i_max,n,dim_k
  logical,intent(out) :: imax_flag,eps_flag,dimk_flag
  logical,intent(out) :: info_flag,log_flag
  logical,intent(out) :: lanczos_flag,bicgstab_flag,gmres_flag

  character(len=80) :: param
  character(len=40) :: p_var,p_val
  integer :: i,j

  interface
     subroutine msolve_help()
     endsubroutine msolve_help
  endinterface

  n=get_params_nb(filename)
  if(n==0) call msolve_help()
  do i=1,n
     param=get_param(filename,i)
     if(param(1:1)=='-') then
        j=index(param,'=')
        if(j==0) j=len(param)+1
        p_var=param(2:j-1)
        p_val=param(j+1:len(param))
        select case(p_var)
        case('help')
           call msolve_help()
        case('imax')
           i_max=char2int(p_val)
           imax_flag=.false.
        case('eps')
           eps_max=char2double(p_val)
           eps_flag=.false.
        case('dimk')
           dim_k=char2int(p_val)
           dimk_flag=.false.
        case('logtag')
           logtag=p_val
        case('lanczos')
           if((p_val=='1').or.(p_val=='yes')) lanczos_flag=.true.
        case('bicgstab')
           if((p_val=='1').or.(p_val=='yes')) bicgstab_flag=.true.
        case('gmres')
           if((p_val=='1').or.(p_val=='yes')) gmres_flag=.true.
        case('info')
           if((p_val=='1').or.(p_val=='yes')) info_flag=.true.
        case('log')
           if((p_val=='0').or.(p_val=='no')) log_flag=.false.
        endselect
     endif
  enddo
return
endsubroutine msolve_params
