! checks the reason why the algorithm stopped,
! and ends the log file or the standard output information, 
subroutine msolve_post(mode,filename,x,log_flag,info_flag,&
     eps_end,eps_max,i_end,i_max,fail_flag,n,nval)
  use misc_interface
  implicit none
  character(len=*),intent(in) :: mode,filename
  real(kind(0.d0)),dimension(:),intent(in) :: x
  logical,intent(in) :: log_flag,info_flag,fail_flag
  integer,intent(in) :: n,nval,i_max,i_end
  real(kind(0.d0)),intent(in) :: eps_max,eps_end

  character(len=160) :: out
  integer :: m,i

  if(log_flag) then
     if(trim(mode)=='lanczos') then
        if(eps_end<=eps_max) then
           call log_add('# EPS REACHED, ITERATION STOPPED')
        else
           call log_add('# IMAX REACHED, ITERATION STOPPED')
        endif
     elseif((trim(mode)=='bicgstab').or.(trim(mode)=='gmres')) then
        if(fail_flag) then
           call log_add('# ALGORITHM FAILED, ITERATION STOPPED')
        elseif(eps_end<=eps_max) then
           call log_add('# EPS REACHED, ITERATION STOPPED')
        else
           call log_add('# IMAX REACHED, ITERATION STOPPED')
        endif
     endif
  endif
  
  if(info_flag) then
     out='# '//trim(filename)//' '//trim(adjustl(int2char(n)))&
          //' '//trim(adjustl(int2char(nval)))
     if(trim(mode)=='lanczos') then
        if(eps_end<=eps_max) then
           out=trim(out)//' - lanczos - epsilon reached'
        else
           out=trim(out)//' - lanczos - max iter reached'
        endif
     elseif(trim(mode)=='bicgstab') then
        if(fail_flag) then
           out=trim(out)//' - bicgstab - failed'
        elseif(eps_end<=eps_max) then
           out=trim(out)//' - bicgstab - epsilon reached'
        else
           out=trim(out)//' - bicgstab - max iter reached'
        endif
     elseif(trim(mode)=='gmres') then
        if(fail_flag) then
           out=trim(out)//' - gmres - failed'
        elseif(eps_end<=eps_max) then
           out=trim(out)//' - gmres - epsilon reached'
        else
           out=trim(out)//' - gmres - max iter reached'
        endif
     endif
     out=trim(out)//' i : '//trim(adjustl(int2char(i_end)))//&
          ' - eps : '//trim(adjustl(double2char(eps_end)))
     print *,out
     m=min(n,10)
     do i=1,m
        print *,x(i)
     enddo
  endif
return
endsubroutine msolve_post

