! starts the log file, if needed
subroutine msolve_pre(mode,log_flag,logname,n,nval,&
     i_max,eps_max,dim_k)
  use misc_interface
  implicit none
  character(len=*),intent(in) :: mode,logname
  logical,intent(in) :: log_flag
  integer,intent(in) :: n,nval,i_max,dim_k
  real(kind(0.d0)),intent(in) :: eps_max

  if(log_flag) then
     if(trim(mode)=='lanczos') then
        call log_init('log/lanczos'//trim(adjustl(logname))//'.log')
        call log_add('# LANCZOS-ORTHOMIN RESOLUTION')
     elseif(trim(mode)=='bicgstab') then
        call log_init('log/bicgstab'//trim(adjustl(logname))//'.log')
        call log_add('# BICGSTAB RESOLUTION')
     elseif(trim(mode)=='gmres') then
        call log_init('log/gmres'//trim(adjustl(logname))//'.log')
        call log_add('# RESTARTED GMRES RESOLUTION')
     endif
     call log_add('# SIZE '//trim(adjustl(int2char(n)))//&
          ' - NVAL '//trim(adjustl(int2char(nval))))
     if(trim(mode)=='gmres') then
        call log_add('# IMAX '//trim(adjustl(int2char(i_max)))//&
             ' - EPS '//trim(adjustl(double2char(eps_max)))//&
             ' - KDIM '//trim(adjustl(int2char(dim_k))))
     else
        call log_add('# IMAX '//trim(adjustl(int2char(i_max)))//&
             ' - EPS '//trim(adjustl(double2char(eps_max))))
     endif
     call log_add('# ITER | TIME | RELATIVE ERROR')
  endif
return
endsubroutine msolve_pre

