subroutine error(code) 
  integer,intent(in) :: code

  select case(code)
  case(100:199)
     call error100(code) ! special
  case(200:299)
     call error200(code) ! system problems : io, memory
  case(300:399)
     call error300(code) ! errors in data
  case(400:499)
     call error400(code) ! errors in algorithm
  endselect
  return
endsubroutine error

subroutine error100(code)
  integer,intent(in) :: code

  select case(code)
  case(101)
     print *,'ERROR: error test OK'
  endselect
  return
endsubroutine error100

subroutine error200(code)
  integer,intent(in) :: code

  select case(code)
  case(201)
     print *,'ERROR: in/out error while opening a file'
  case(202)
     print *,'ERROR: in/out error while writing in a file'
  case(203)
     print *,'ERROR: in/out error while reading a file'
  case(204)
     print *,'ERROR: memory allocation error'
  endselect
  return
endsubroutine error200

subroutine error300(code)
  integer :: code

  select case(code)
  case(301)
     print *,'ERROR: matrix in Harwell-Boeing file must be square'
  case(302)
     print *,'ERROR: matrix sizes in Harwell-Boeing file must be <=1'
  case(303)
     print *,'ERROR: matrix in Harwell-Boeing file must not be empty'
  case(304)
     print *,'ERROR: matrix in Harwell-Boeing file must be Real Unsymmetric Assemblied'
  case(305)
     print *,'ERROR: compressed matrix should not have empty cells on the diagonal'
  endselect
  return
endsubroutine error300

subroutine error400(code)
  integer :: code

  select case(code)
  case(401)
     print *,'ERROR: size does not match in matrix-vector product'
  case(402)
     print *,'ERROR: size does not match in matrix-matrix product'
  case(403)
     print *,'ERROR: accessing a matrix cell with row number < 1'
  case(404)
     print *,'ERROR: accessing a matrix cell with row number > matrix size'
  case(405)
     print *,'ERROR: accessing a matrix cell with column number < 1'
  case(406)
     print *,'ERROR: accessing a matrix cell with column number > matrix size'
  case(407)
     print *,'ERROR: two vectors should have the same size'
  case(408)
     print *,'ERROR: vector should have zero values'
  case(409)
     print *,'ERROR: size does not match in matrix-vector system resolution'
  case(410)
     print *,'ERROR: size does not match in vector-matrix product'
  endselect
  return
endsubroutine error400
