! all the interfaces for the 'misc' units
module misc_interface
  interface 
     subroutine error(code)
       integer,intent(in) :: code
     endsubroutine error
     function get_fileunit() result(fileunit)
       integer :: fileunit
     endfunction get_fileunit
     function get_params_nb(filename) result(n)
       character(len=*),intent(in) :: filename
       integer :: n
     endfunction get_params_nb
     function get_param(filename,n) result(p)
       character(len=80) :: p 
       character(len=*),intent(in) :: filename
       integer,intent(in) :: n
     endfunction get_param
     subroutine i_vect_alloc(v,n)
       integer,allocatable,dimension(:),intent(out) :: v
       integer,intent(in) :: n
     endsubroutine i_vect_alloc
     subroutine d_vect_alloc(v,n)
       real(kind(0.d0)),allocatable,dimension(:),intent(out) :: v
       integer,intent(in) :: n
     endsubroutine d_vect_alloc
     subroutine d_mat_alloc(a,n1,n2)
       real(kind(0.d0)),allocatable,dimension(:,:),intent(out) :: a
       integer,intent(in) :: n1
       integer,optional,intent(in) :: n2
     endsubroutine d_mat_alloc
     function rel_diff(a,b) result(d)
       real(kind(0.d0)),dimension(:),intent(in) :: a,b
       real(kind(0.d0)) :: d
     endfunction rel_diff
     subroutine log_add(logline,filename_param)
       character(len=*),optional,intent(in) :: logline
       character(len=*),optional,intent(in) :: filename_param
     endsubroutine log_add
     subroutine log_init(filename)
       character(len=*),intent(in) :: filename
     endsubroutine log_init
     function int2char(i) result(c)
       integer,intent(in) :: i
       character(len=20) :: c
     endfunction int2char
     function real2char(r) result(c)
       real,intent(in) :: r
       character(len=40) :: c
     endfunction real2char
     function double2char(d) result(c)
       real(kind(0.d0)),intent(in) :: d
       character(len=60) :: c
     endfunction double2char
     function char2int(c) result(i)
       character(len=*),intent(in) :: c
       integer :: i
     endfunction char2int
     function char2real(c) result(r)
       character(len=*),intent(in) :: c
       real :: r
     endfunction char2real
     function char2double(c) result(d)
       character(len=*),intent(in) :: c
       real(kind(0.d0)) :: d
     endfunction char2double
  endinterface
endmodule misc_interface
