! calculates the relative difference from a to b
function rel_diff(a,b) result(d)
  implicit none
  real(kind(0.d0)),dimension(:),intent(in) :: a,b
  real(kind(0.d0)) :: d
  real(kind(0.d0)),allocatable,dimension(:) :: c
  integer :: i,n
  interface
     subroutine error(code)
       integer,intent(in) :: code
     endsubroutine error
     subroutine d_vect_alloc(v,n)
       real(kind(0.d0)),allocatable,dimension(:),intent(out) :: v
       integer,intent(in) :: n
     endsubroutine d_vect_alloc
  endinterface

  n=size(b)
  if(size(a)/=n) call error(407)
  call d_vect_alloc(c,n)
  c=a-b
  do i=1,n
     if(b(i)/=0.d0) then
        c(i)=abs(c(i)/b(i))
     else 
        c(i)=abs(c(i))
     endif
  enddo
  d=maxval(c)

endfunction rel_diff
