! all the interfaces for the 'misc' units
module solve_interface
  interface 
     subroutine solve_lanczos(a,b,x,eps_max,i_max,eps_end,i_end,log)
       use csm_mod
       type(csmat),intent(in) :: a
       real(kind(0.d0)),dimension(:),intent(in) :: b
       real(kind(0.d0)),dimension(:),intent(inout) :: x
       real(kind(0.d0)),intent(in) :: eps_max
       integer,intent(in) :: i_max
       real(kind(0.d0)),optional,intent(out) :: eps_end
       integer,optional,intent(out) :: i_end
       logical,optional,intent(in) :: log
     endsubroutine solve_lanczos

     subroutine solve_bicgstab(a,b,x,eps_max,i_max,eps_end,i_end,fail,log)
       use csm_mod
       type(csmat),intent(in) :: a
       real(kind(0.d0)),dimension(:),intent(in) :: b
       real(kind(0.d0)),dimension(:),intent(inout) :: x
       real(kind(0.d0)),intent(in) :: eps_max
       integer,intent(in) :: i_max
       real(kind(0.d0)),optional,intent(out) :: eps_end
       integer,optional,intent(out) :: i_end
       logical,optional,intent(out) :: fail
       logical,optional,intent(in) :: log
     endsubroutine solve_bicgstab

     subroutine solve_gmres(a,b,x,eps_max,i_max,eps_end,i_end,dim_k,fail,log)
       use csm_mod
       type(csmat),intent(in) :: a
       real(kind(0.d0)),dimension(:),intent(in) :: b
       real(kind(0.d0)),dimension(:),intent(inout) :: x
       real(kind(0.d0)),intent(in) :: eps_max
       integer,intent(in) :: i_max,dim_k
       real(kind(0.d0)),optional,intent(out) :: eps_end
       integer,optional,intent(out) :: i_end
       logical,optional,intent(out) :: fail
       logical,optional,intent(in) :: log
     endsubroutine solve_gmres
  endinterface
endmodule solve_interface
